Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs	(revision 14048)
@@ -31,9 +31,9 @@
   [Item("BinPacking2D", "Represents a single-bin packing for a 2D bin-packing problem.")]
   [StorableClass]
-  public class BinPacking2D : BinPacking<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> {
+  public class BinPacking2D : BinPacking<PackingPosition, RectangularPackingShape, RectangularPackingItem> {
 
     public BinPacking2D(RectangularPackingShape binMeasures)
       : base(binMeasures) {
-      ExtremePoints = new SortedSet<TwoDimensionalPacking>(new EPComparer2D());
+      ExtremePoints = new SortedSet<PackingPosition>(new EPComparer2D());
       ExtremePoints.Add(binMeasures.Origin);
     }
@@ -42,5 +42,5 @@
     protected BinPacking2D(BinPacking2D original, Cloner cloner)
       : base(original, cloner) {
-      this.ExtremePoints = new SortedSet<TwoDimensionalPacking>(original.ExtremePoints, new EPComparer2D());
+      this.ExtremePoints = new SortedSet<PackingPosition>(original.ExtremePoints, new EPComparer2D());
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -48,5 +48,5 @@
     }
 
-    protected override void GenerateNewExtremePointsForNewItem(RectangularPackingItem newItem, TwoDimensionalPacking position) {
+    protected override void GenerateNewExtremePointsForNewItem(RectangularPackingItem newItem, PackingPosition position) {
 
       int newWidth = position.Rotated ? newItem.Height : newItem.Width;
@@ -54,25 +54,25 @@
 
       //Find ExtremePoints beginning from sourcepointX
-      var sourcePointX = new TwoDimensionalPacking(0, position.X + newWidth, position.Y);
+      var sourcePointX = new PackingPosition(0, position.X + newWidth, position.Y);
       if (sourcePointX.X < BinMeasures.Width && sourcePointX.Y < BinMeasures.Height) {
         //Traversing down the y-axis        
-        var newPoint = new TwoDimensionalPacking(0, sourcePointX.X, sourcePointX.Y - 1);
+        var newPoint = new PackingPosition(0, sourcePointX.X, sourcePointX.Y - 1);
         while (sourcePointX.Y > 0 && !IsPointOccupied(newPoint)) {
           sourcePointX = newPoint;
-          newPoint = new TwoDimensionalPacking(0, sourcePointX.X, sourcePointX.Y - 1);
-        }
-        ExtremePoints.Add(new TwoDimensionalPacking(0, sourcePointX.X, sourcePointX.Y));
+          newPoint = new PackingPosition(0, sourcePointX.X, sourcePointX.Y - 1);
+        }
+        ExtremePoints.Add(new PackingPosition(0, sourcePointX.X, sourcePointX.Y));
       }
 
       //Find ExtremePoints beginning from sourcepointY
-      var sourcePointY = new TwoDimensionalPacking(0, position.X, position.Y + newItem.Height);
+      var sourcePointY = new PackingPosition(0, position.X, position.Y + newItem.Height);
       if (sourcePointY.X < BinMeasures.Width && sourcePointY.Y < BinMeasures.Height) {
         //Traversing down the x-axis  
-        var newPoint = new TwoDimensionalPacking(0, sourcePointY.X - 1, sourcePointY.Y);
+        var newPoint = new PackingPosition(0, sourcePointY.X - 1, sourcePointY.Y);
         while (sourcePointY.X > 0 && !IsPointOccupied(newPoint)) {
           sourcePointY = newPoint;
-          newPoint = new TwoDimensionalPacking(0, sourcePointY.X - 1, sourcePointY.Y);
-        }
-        ExtremePoints.Add(new TwoDimensionalPacking(0, sourcePointY.X, sourcePointY.Y));
+          newPoint = new PackingPosition(0, sourcePointY.X - 1, sourcePointY.Y);
+        }
+        ExtremePoints.Add(new PackingPosition(0, sourcePointY.X, sourcePointY.Y));
       }
 
@@ -85,5 +85,5 @@
     }
 
-    public override TwoDimensionalPacking FindExtremePointForItem(RectangularPackingItem measures, bool rotated, bool stackingConstraints) {
+    public override PackingPosition FindExtremePointForItem(RectangularPackingItem measures, bool rotated, bool stackingConstraints) {
       RectangularPackingItem item = new RectangularPackingItem(
         rotated ? measures.Height : measures.Width,
@@ -97,22 +97,22 @@
         var currentPoint = ExtremePoints.ElementAt(epIndex);
 
-        var result = new TwoDimensionalPacking(currentPoint.AssignedBin, currentPoint.X, currentPoint.Y, rotated);
+        var result = new PackingPosition(currentPoint.AssignedBin, currentPoint.X, currentPoint.Y, rotated);
         return result;
       }
       return null;
     }
-    public override TwoDimensionalPacking FindPositionBySliding(RectangularPackingItem measures, bool rotated) {
-      TwoDimensionalPacking currentPosition = new TwoDimensionalPacking(0,
+    public override PackingPosition FindPositionBySliding(RectangularPackingItem measures, bool rotated) {
+      PackingPosition currentPosition = new PackingPosition(0,
         BinMeasures.Width - (rotated ? measures.Height : measures.Width),
         BinMeasures.Height - (rotated ? measures.Width : measures.Height), rotated);
       //Slide the item as far as possible to the left
-      while (IsPositionFeasible(measures, TwoDimensionalPacking.MoveLeft(currentPosition))
-        || IsPositionFeasible(measures, TwoDimensionalPacking.MoveDown(currentPosition))) {
+      while (IsPositionFeasible(measures, PackingPosition.MoveLeft(currentPosition))
+        || IsPositionFeasible(measures, PackingPosition.MoveDown(currentPosition))) {
         //Slide the item as far as possible to the bottom
-        while (IsPositionFeasible(measures, TwoDimensionalPacking.MoveDown(currentPosition))) {
-          currentPosition = TwoDimensionalPacking.MoveDown(currentPosition);
-        }
-        if (IsPositionFeasible(measures, TwoDimensionalPacking.MoveLeft(currentPosition)))
-          currentPosition = TwoDimensionalPacking.MoveLeft(currentPosition);
+        while (IsPositionFeasible(measures, PackingPosition.MoveDown(currentPosition))) {
+          currentPosition = PackingPosition.MoveDown(currentPosition);
+        }
+        if (IsPositionFeasible(measures, PackingPosition.MoveLeft(currentPosition)))
+          currentPosition = PackingPosition.MoveLeft(currentPosition);
       }
 
@@ -165,5 +165,5 @@
     }
 
-    public override int ShortestPossibleSideFromPoint(TwoDimensionalPacking position) {
+    public override int ShortestPossibleSideFromPoint(PackingPosition position) {
       int shortestSide = int.MaxValue;
       int width = BinMeasures.Width;
@@ -173,12 +173,12 @@
         return shortestSide;
 
-      TwoDimensionalPacking current = new TwoDimensionalPacking(0, position.X, position.Y);
-      while (current.X < width && IsPointOccupied(current)) { current = TwoDimensionalPacking.MoveRight(current); }
+      PackingPosition current = new PackingPosition(0, position.X, position.Y);
+      while (current.X < width && IsPointOccupied(current)) { current = PackingPosition.MoveRight(current); }
       if (current.X - position.X < shortestSide)
         shortestSide = current.X - position.X;
 
 
-      current = new TwoDimensionalPacking(0, position.X, position.Y);
-      while (current.Y < height && IsPointOccupied(current)) { current = TwoDimensionalPacking.MoveUp(current); }
+      current = new PackingPosition(0, position.X, position.Y);
+      while (current.Y < height && IsPointOccupied(current)) { current = PackingPosition.MoveUp(current); }
       if (current.Y - position.Y < shortestSide)
         shortestSide = current.Y - position.Y;
@@ -186,5 +186,5 @@
       return shortestSide;
     }
-    public override bool IsStaticStable(RectangularPackingItem item, TwoDimensionalPacking position) {
+    public override bool IsStaticStable(RectangularPackingItem item, PackingPosition position) {
       throw new NotImplementedException();
     }
@@ -196,5 +196,5 @@
       }
     }
-    protected override void AddNewItemToOccupationLayers(int itemID, RectangularPackingItem measures, TwoDimensionalPacking position) {
+    protected override void AddNewItemToOccupationLayers(int itemID, RectangularPackingItem measures, PackingPosition position) {
       int x1 = position.X / 10;
       int x2 = (position.X + (position.Rotated ? measures.Height : measures.Width)) / 10;
@@ -203,8 +203,8 @@
         OccupationLayers[i].Add(itemID);
     }
-    protected override List<int> GetLayerItemIDs(TwoDimensionalPacking position) {
+    protected override List<int> GetLayerItemIDs(PackingPosition position) {
       return OccupationLayers[position.X / 10];
     }
-    protected override List<int> GetLayerItemIDs(RectangularPackingItem measures, TwoDimensionalPacking position) {
+    protected override List<int> GetLayerItemIDs(RectangularPackingItem measures, PackingPosition position) {
       List<int> result = new List<int>();
       int x1 = position.X / 10;
@@ -217,6 +217,6 @@
     }
   }
-  public class EPComparer2D : IComparer<TwoDimensionalPacking> {
-    public int Compare(TwoDimensionalPacking a, TwoDimensionalPacking b) {
+  public class EPComparer2D : IComparer<PackingPosition> {
+    public int Compare(PackingPosition a, PackingPosition b) {
       int result = a.X.CompareTo(b.X);
       if (result == 0)
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftGroupingVectorDecoder.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftGroupingVectorDecoder.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftGroupingVectorDecoder.cs	(revision 14048)
@@ -31,5 +31,5 @@
   [Item("Identical bin two dimensional grouping vector decoder", "<Description missing...>")]
   [StorableClass]
-  public class BottomLeftGroupingVectorDecoder : PackingSolutionDecoder<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, I2DGVDecoder {
+  public class BottomLeftGroupingVectorDecoder : PackingSolutionDecoder<PackingPosition, RectangularPackingShape, RectangularPackingItem>, I2DGVDecoder {
     public BottomLeftGroupingVectorDecoder() : base() {}
     [StorableConstructor]
@@ -42,5 +42,5 @@
     }
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as GroupingVectorEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type GroupingVector");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftMultiComponentVectorDecoder.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftMultiComponentVectorDecoder.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftMultiComponentVectorDecoder.cs	(revision 14048)
@@ -31,5 +31,5 @@
   [Item("Identical bin two dimensional multi component vector decoder", "<Description missing...>")]
   [StorableClass]
-  public class BottomLeftMultiComponentVectorDecoder : PackingSolutionDecoder<TwoDimensionalPacking,RectangularPackingShape, RectangularPackingItem>, I2DMCVDecoder {
+  public class BottomLeftMultiComponentVectorDecoder : PackingSolutionDecoder<PackingPosition,RectangularPackingShape, RectangularPackingItem>, I2DMCVDecoder {
     public BottomLeftMultiComponentVectorDecoder() : base() {}
     [StorableConstructor]
@@ -42,5 +42,5 @@
     }
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as MultiComponentVectorEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type MultiComponent Vector");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftPackingSequenceDecoder.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftPackingSequenceDecoder.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/BL/BottomLeftPackingSequenceDecoder.cs	(revision 14048)
@@ -32,5 +32,5 @@
   [Item("Identical bin, two dimensional, direct permutation decoder", "<Description missing...>")]
   [StorableClass]
-  public class BottomLeftPackingSequenceDecoder : PackingSolutionDecoder<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, I2DPSDecoder {
+  public class BottomLeftPackingSequenceDecoder : PackingSolutionDecoder<PackingPosition, RectangularPackingShape, RectangularPackingItem>, I2DPSDecoder {
 
     public BottomLeftPackingSequenceDecoder(): base() { }
@@ -44,5 +44,5 @@
     }
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as PackingSequenceEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type PackingSequence");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointGroupingVectorDecoder2D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointGroupingVectorDecoder2D.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointGroupingVectorDecoder2D.cs	(revision 14048)
@@ -32,5 +32,5 @@
   [Item("Identical bin, two dimensional, extreme points based decoder for the GroupingVector encoding.", "<Description missing...>")]
   [StorableClass]
-  public class ExtremePointGroupingVectorDecoder2D : PackingSolutionDecoder<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, I2DGVDecoder {
+  public class ExtremePointGroupingVectorDecoder2D : PackingSolutionDecoder<PackingPosition, RectangularPackingShape, RectangularPackingItem>, I2DGVDecoder {
     public ExtremePointGroupingVectorDecoder2D () : base() {}
     [StorableConstructor]
@@ -43,5 +43,5 @@
     }
 
-    public static PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> Decode(GroupingVectorEncoding solution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public static PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> Decode(GroupingVectorEncoding solution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       Solution result = new Solution(binMeasures, true, false);
       result.Pack(solution, itemMeasures);
@@ -49,5 +49,5 @@
     }
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as GroupingVectorEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type GroupingVector");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointMultiComponentVectorDecoder2D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointMultiComponentVectorDecoder2D.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointMultiComponentVectorDecoder2D.cs	(revision 14048)
@@ -31,5 +31,5 @@
   [Item("Identical bin, two dimensional, extreme points based decoder for the MultiComponentVector encoding.", "<Description missing...>")] // TODO
   [StorableClass]
-  public class ExtremePointMultiComponentVectorDecoder2D : PackingSolutionDecoder<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, I2DMCVDecoder {
+  public class ExtremePointMultiComponentVectorDecoder2D : PackingSolutionDecoder<PackingPosition, RectangularPackingShape, RectangularPackingItem>, I2DMCVDecoder {
     public ExtremePointMultiComponentVectorDecoder2D () : base() {}
     [StorableConstructor]
@@ -42,5 +42,5 @@
     }
 
-    public static PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> Decode(MultiComponentVectorEncoding solution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public static PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> Decode(MultiComponentVectorEncoding solution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       Solution result = new Solution(binMeasures, true, false);
       result.Pack(solution, itemMeasures);
@@ -48,5 +48,5 @@
     }
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as MultiComponentVectorEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type MultiComponentVector");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointPackingSequenceDecoder2D.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointPackingSequenceDecoder2D.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/Decoders/EP/ExtremePointPackingSequenceDecoder2D.cs	(revision 14048)
@@ -32,5 +32,5 @@
   [Item("Identical bin, two dimensional, extreme points based decoder for the PackingSequence encoding.", "<Description missing...>")] // TODO
   [StorableClass]
-  public class ExtremePointPackingSequenceDecoder2D : PackingSolutionDecoder<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, I2DPSDecoder {
+  public class ExtremePointPackingSequenceDecoder2D : PackingSolutionDecoder<PackingPosition, RectangularPackingShape, RectangularPackingItem>, I2DPSDecoder {
     public ExtremePointPackingSequenceDecoder2D () : base() {}
     [StorableConstructor]
@@ -44,5 +44,5 @@
 
 
-    public override PackingPlan<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
+    public override PackingPlan<PackingPosition, RectangularPackingShape, RectangularPackingItem> CreatePackingPlanFromEncoding(IItem encodedSolution, RectangularPackingShape binMeasures, ItemList<RectangularPackingItem> itemMeasures) {
       var solution = encodedSolution as PackingSequenceEncoding;
       if (solution == null) throw new InvalidOperationException("Encoding is not of type PackingSequence");
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/HeuristicLab.Problems.BinPacking2D-3.3.csproj
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/HeuristicLab.Problems.BinPacking2D-3.3.csproj	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/HeuristicLab.Problems.BinPacking2D-3.3.csproj	(revision 14048)
@@ -172,4 +172,5 @@
     <Compile Include="MoveEvaluators\PackingMoveEvaluator2DMCV.cs" />
     <Compile Include="MoveEvaluators\PackingMoveEvaluator2DPS.cs" />
+    <Compile Include="PackingPosition.cs" />
     <Compile Include="PackingRatioRectangularIdenticalBinEvaluator.cs" />
     <Compile Include="Plugin.cs" />
@@ -179,5 +180,4 @@
     <Compile Include="RectangularPackingShape.cs" />
     <Compile Include="Solution.cs" />
-    <Compile Include="TwoDimensionalPacking.cs" />
   </ItemGroup>
   <ItemGroup>
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DGV.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DGV.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DGV.cs	(revision 14048)
@@ -29,5 +29,5 @@
   [Item("GroupingVectorMoveEvaluator2D", "Class for evaluating packing moves for 2dimensional problems.")]
   [StorableClass]
-  public class PackingMoveEvaluator2DGV : PackingMoveEvaluator<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IGroupingVectorMoveOperator, I2DOperator {
+  public class PackingMoveEvaluator2DGV : PackingMoveEvaluator<PackingPosition, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IGroupingVectorMoveOperator, I2DOperator {
     [StorableConstructor]
     protected PackingMoveEvaluator2DGV(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DMCV.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DMCV.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DMCV.cs	(revision 14048)
@@ -29,5 +29,5 @@
   [Item("MultiComponentVectorMoveEvaluator2D", "Class for evaluating packing moves for 2dimensional problems.")]
   [StorableClass]
-  public class PackingMoveEvaluator2DMCV : PackingMoveEvaluator<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IMultiComponentVectorMoveOperator, I2DOperator {
+  public class PackingMoveEvaluator2DMCV : PackingMoveEvaluator<PackingPosition, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IMultiComponentVectorMoveOperator, I2DOperator {
     [StorableConstructor]
     protected PackingMoveEvaluator2DMCV(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DPS.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DPS.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/MoveEvaluators/PackingMoveEvaluator2DPS.cs	(revision 14048)
@@ -29,5 +29,5 @@
   [Item("PackingSequenceMoveEvaluator2D", "Class for evaluating packing moves for 2dimensional problems.")]
   [StorableClass]
-  public class PackingMoveEvaluator2DPS : PackingMoveEvaluator<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IPackingSequenceMoveOperator, I2DOperator {
+  public class PackingMoveEvaluator2DPS : PackingMoveEvaluator<PackingPosition, RectangularPackingShape, RectangularPackingItem>, ISingleObjectiveMoveEvaluator, IPackingSequenceMoveOperator, I2DOperator {
     [StorableConstructor]
     protected PackingMoveEvaluator2DPS(bool deserializing) : base(deserializing) { }
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingPosition.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingPosition.cs	(revision 14048)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingPosition.cs	(revision 14048)
@@ -0,0 +1,87 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Problems.BinPacking2D {
+  [Item("Packing Position (2d)", "Represents a packing-position associated with a two dimensional packing-problem.")]
+  [StorableClass]
+  // PackingPosition is an immutable class (and handled as value type concerning Equals and GetHashCode())
+  public class PackingPosition : BinPacking.PackingPosition {
+    [Storable]
+    private readonly int x;
+    public int X { get { return x; } }
+
+    [Storable]
+    private readonly int y;
+    public int Y { get { return y; } }
+
+    [StorableConstructor]
+    protected PackingPosition(bool deserializing) : base(deserializing) { }
+    protected PackingPosition(PackingPosition original, Cloner cloner)
+      : base(original, cloner) {
+      x = original.X;
+      y = original.Y;
+    }
+
+    public PackingPosition(int assignedBin, int x, int y, bool rotated = false)
+      : base(assignedBin, rotated) {
+      this.x = x;
+      this.y = y;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PackingPosition(this, cloner);
+    }
+    
+    public override string ToString() {
+      return string.Format("[AssignedBin: {0}; ({1},{2})]", AssignedBin, x, y);
+    }
+
+    public override bool Equals(object obj) {
+      var other = obj as PackingPosition;
+      if (other != null)
+        return (other.X == this.X && other.Y == this.Y && base.Equals(other));
+      else return false;
+    }
+
+    public override int GetHashCode() {
+      return base.GetHashCode() + 13 * X + 17 * Y;
+    }
+
+    public static PackingPosition MoveLeft(PackingPosition original) {
+      return new PackingPosition(original.AssignedBin, original.X - 1, original.Y, original.Rotated);
+    }
+    public static PackingPosition MoveDown(PackingPosition original) {
+      return new PackingPosition(original.AssignedBin, original.X, original.Y - 1, original.Rotated);
+    }
+
+    public static PackingPosition MoveRight(PackingPosition original) {
+      return new PackingPosition(original.AssignedBin, original.X + 1, original.Y, original.Rotated);
+    }
+    public static PackingPosition MoveUp(PackingPosition original) {
+      return new PackingPosition(original.AssignedBin, original.X, original.Y + 1, original.Rotated);
+    }
+
+  }
+}
Index: branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingRatioRectangularIdenticalBinEvaluator.cs
===================================================================
--- branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingRatioRectangularIdenticalBinEvaluator.cs	(revision 14047)
+++ branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/PackingRatioRectangularIdenticalBinEvaluator.cs	(revision 14048)
@@ -29,5 +29,5 @@
   [Item("Packing-Ratio Rectangular Identical-Bin Evaluator", "Represents an evaluation-algorithm for rectangular-shaped bin-packing problems with identical bins which calculates the ratio between packed and unpacked space. Found in Falkenauer:1996")]
   [StorableClass]
-  public class PackingRatioRectangularIdenticalBinEvaluator : PackingRatioRegularIdenticalBinEvaluator<TwoDimensionalPacking, RectangularPackingShape, RectangularPackingItem> {
+  public class PackingRatioRectangularIdenticalBinEvaluator : PackingRatioRegularIdenticalBinEvaluator<PackingPosition, RectangularPackingShape, RectangularPackingItem> {
 
     [StorableConstructor]
